#ifndef _VECTOR2_H_
#define _VECTOR2_H_

// Hilfsprogramme 
#include <iostream>
using namespace std;
#include <cstdlib>

// Erweiterung der Vektorroutinen aus vector.h
// z.b. vec_dplus(n,x,mx,y,my,z,mz) berechnet
// x(mx*i)=y(my*i)+z(mz*i), 0=1,...,n-1
// analog bei den anderen Routinen

// Routinen heissen v_{i,d}{op}
// i oder d zeigt Datentyp (integer/double)
// op (plus,minus,mult,0mult,copy) steht fuer die Operation
// Achtung ueberladen

void vdcopy(int n,double* x,int mx,double* z,int mz)
{
  int i,ix,iz;
  ix=0;
  iz=0;
  for (i=0;i<n;i++)
    {
      x[ix]=z[iz];
      ix+=mx;
      iz+=mz;
    }
}

void vicopy(int n,int* x,int mx,int* z,int mz)
{
  int i,ix,iz;
  ix=0;
  iz=0;
  for (i=0;i<n;i++)
    {
      x[ix]=z[iz];
      ix+=mx;
      iz+=mz;
    }
}



void vdplus(int n,double* x,int mx,double* y, int my,
                                      double* z,int mz)
{
  int i,iz,ix,iy;
  ix=0;
  iy=0;
  iz=0;
  for (i=0;i<n;i++)
    {
      z[iz]=x[ix]+y[iy];
      ix+=mx;
      iy+=my;
      iz+=mz;
    }
}

void vdminus(int n,double* x,int mx,double* y, int my,
                                   double* z,int mz)
{
  int i,iz,ix,iy;
  ix=0;
  iy=0;
  iz=0;
  for (i=0;i<n;i++)
    {
      z[iz]=x[ix]-y[iy];
      ix+=mx;
      iy+=my;
      iz+=mz;
    }
}

void vimult(int n,int* x,int mx,int* y, int my,
                                      int* z,int mz)
{
  int i,iz,ix,iy;
  ix=0;
  iy=0;
  iz=0;
  for (i=0;i<n;i++)
    {
      z[iz]=x[ix]*y[iy];
      ix+=mx;
      iy+=my;
      iz+=mz;
    }
}

void vidiv(int n,int* x,int mx,int* y, int my,
                                     int* z,int mz)
{
  int i,iz,ix,iy;
  ix=0;
  iy=0;
  iz=0;
  for (i=0;i<n;i++)
    {
      z[iz]=x[ix]/y[iy];
      ix+=mx;
      iy+=my;
      iz+=mz;
    }
}

void viplus(int n,int* x,int mx,int* y, int my,
                                     int* z,int mz)
{
  int i,iz,ix,iy;
  ix=0;
  iy=0;
  iz=0;
  for (i=0;i<n;i++)
    {
      z[iz]=x[ix]+y[iy];
      ix+=mx;
      iy+=my;
      iz+=mz;
    }
}

void viminus(int n,int* x,int mx,int* y, int my,
                                  int* z,int mz)
{
  int i,iz,ix,iy;
  ix=0;
  iy=0;
  iz=0;
  for (i=0;i<n;i++)
    {
      z[iz]=x[ix]-y[iy];
      ix+=mx;
      iy+=my;
      iz+=mz;
    }
}

void vdmult(int n,double* x,int mx,double* y, int my,
                                 double* z,int mz)
{
  int i,iz,ix,iy;
  ix=0;
  iy=0;
  iz=0;
  for (i=0;i<n;i++)
    {
      z[iz]=x[ix]*y[iy];
      ix+=mx;
      iy+=my;
      iz+=mz;
    }
}
void vddiv(int n,double* x,int mx,double* y, 
                      int my,double* z,int mz)
{
  int i,iz,ix,iy;
  ix=0;
  iy=0;
  iz=0;
  for (i=0;i<n;i++)
    {
      z[iz]=x[ix]/y[iy];
      ix+=mx;
      iy+=my;
      iz+=mz;
    }
}


void vd0mult(int n,double* x,int mx,double* y,
                  int my,double* z,int mz)
{
  int i,iz,ix,iy;
  ix=0;
  iy=0;
  iz=0;
  for (i=0;i<n;i++)
    {
       if (y[iy]!=0)
	{
        z[iz]=x[ix];
        }
      else
        {
         z[iz]=0;
        }    
      ix+=mx;
      iy+=my;
      iz+=mz;
    }
}

#endif
